`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2025/03/31 09:08:49
// Design Name: 
// Module Name: ad7606c_init_table
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module ad7606c_init_table(
    input clk,
    input [5:0]addr,
    output reg [15:0] data
);

reg [15:0] rom [39:0];

initial begin
    rom[00] = 16'h02_18; //8dout bit4 1 bit3 1
    // úͶȡͨ1-8ģ뷶Χ
    rom[01] = 16'h03_11;  // RANGE_CH1_CH2  0001: 5 V  0000: 2.5 V 
    rom[02] = 16'h04_11;  // RANGE_CH3_CH4  0001: 5 V  0000: 2.5 V 
    rom[03] = 16'h05_11;  // RANGE_CH5_CH6  0001: 5 V  0000: 2.5 V 
    rom[04] = 16'h06_11;  // RANGE_CH7_CH8  0001: 5 V  0000: 2.5 V 
    rom[05] = 16'h07_00;  // ͨĴ
    rom[06] = 16'h08_00;  // ʺ͹ 00-off 0001-2 0010-4 0011-8
    //ͨУ׼
    rom[07] = 16'h09_00;  //  CH1_GAIN. Resolution: 1024 ?. Range: 0 ? to 65,536 ?.
    rom[08] = 16'h0a_00;  //  CH2_GAIN. Resolution: 1024 ?. Range: 0 ? to 65,536 ?.
    rom[09] = 16'h0b_00;  //  CH3_GAIN. Resolution: 1024 ?. Range: 0 ? to 65,536 ?.
    rom[10] = 16'h0c_00;  //  CH4_GAIN. Resolution: 1024 ?. Range: 0 ? to 65,536 ?.
    rom[11] = 16'h0d_00;  //  CH5_GAIN. Resolution: 1024 ?. Range: 0 ? to 65,536 ?.
    rom[12] = 16'h0e_00;  //  CH6_GAIN. Resolution: 1024 ?. Range: 0 ? to 65,536 ?.
    rom[13] = 16'h0f_00;  //  CH7_GAIN. Resolution: 1024 ?. Range: 0 ? to 65,536 ?.
    rom[14] = 16'h10_00;  //  CH8_GAIN. Resolution: 1024 ?. Range: 0 ? to 65,536 ?.
    //ͨƫУ׼
    rom[15] = 16'h11_80;  //  CH1_OFFSET. Range from -512 LSB to +511 LSB.
    rom[16] = 16'h12_80;  //  CH2_OFFSET. Range from -512 LSB to +511 LSB.
    rom[17] = 16'h13_80;  //  CH3_OFFSET. Range from -512 LSB to +511 LSB.
    rom[18] = 16'h14_80;  //  CH4_OFFSET. Range from -512 LSB to +511 LSB.
    rom[19] = 16'h15_80;  //  CH5_OFFSET. Range from -512 LSB to +511 LSB.
    rom[20] = 16'h16_80;  //  CH6_OFFSET. Range from -512 LSB to +511 LSB.
    rom[21] = 16'h17_80;  //  CH7_OFFSET. Range from -512 LSB to +511 LSB.
    rom[22] = 16'h18_80;  //  CH8_OFFSET. Range from -512 LSB to +511 LSB.
    //ͨλУ׼
    rom[23] = 16'h19_00;  //  CH1_PHASE. . Phase delay from 0 ?s to 255 ?s in steps of 1 ?s.
    rom[24] = 16'h1a_00;  //  CH2_PHASE. . Phase delay from 0 ?s to 255 ?s in steps of 1 ?s.
    rom[25] = 16'h1b_00;  //  CH3_PHASE. . Phase delay from 0 ?s to 255 ?s in steps of 1 ?s.
    rom[26] = 16'h1c_00;  //  CH4_PHASE. . Phase delay from 0 ?s to 255 ?s in steps of 1 ?s.
    rom[27] = 16'h1d_00;  //  CH5_PHASE. . Phase delay from 0 ?s to 255 ?s in steps of 1 ?s.
    rom[28] = 16'h1e_00;  //  CH6_PHASE. . Phase delay from 0 ?s to 255 ?s in steps of 1 ?s.
    rom[29] = 16'h1f_00;  //  CH7_PHASE. . Phase delay from 0 ?s to 255 ?s in steps of 1 ?s.
    rom[30] = 16'h20_00;  //  CH8_PHASE. . Phase delay from 0 ?s to 255 ?s in steps of 1 ?s.
    
    rom[31] = 16'h21_01;  //  DIGITAL_DIAG_ENABLE
    rom[32] = 16'h22_00;  //  DIGITAL_DIAG_ERR
    rom[33] = 16'h23_00;  //  OPEN_DETECT_ENABLE
    rom[34] = 16'h24_00;  //  OPEN_DETECTED
    
    // ϶·ãڼڲڵ㡣
    rom[35] = 16'h28_00;  //  DIAGNOSTIC_MUX_CH1_2
    rom[36] = 16'h29_00;  //  DIAGNOSTIC_MUX_CH3_4
    rom[37] = 16'h2a_00;  //  DIAGNOSTIC_MUX_CH5_6
    rom[38] = 16'h2b_00;  //  DIAGNOSTIC_MUX_CH7_8
    
    rom[39] = 16'h2c_00;  //  ·УԶֶ·⡣1ֶ
end

  always @ (posedge clk)
  begin
    data <= rom[addr];
  end


endmodule
