`timescale 1ns / 1ps
/////////////////////////////////////////////////////////////////////////////////
// Company       : 人о·Ƽ޹˾
//                 http://xiaomeige.taobao.com
// Web           : http://www.corecourse.cn
// 
// Create Date   : 
// Module Name   : ad7606c_spi_driver
// Description   : AD7606Cģ
// 
// Dependencies  : 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
/////////////////////////////////////////////////////////////////////////////////


module ad7606c_spi_software_mode_driver2(
    input                               Clk                        ,
    input                               Reset_n                    ,
    input              [  31: 0]        DataNum                    ,
    input              [  31: 0]        Speed_Set                  ,
    input              [31:0]           ADC_SOFT_DATA              ,
    input                               RestartReq                 ,
    output reg                          SDI                        ,
    input                               ad7606_busy                ,
    input                               Dout_A                     ,
    input                               Dout_B                     ,
    input                               Dout_C                     ,
    input                               Dout_D                     ,
    input                               Dout_E                     ,
    input                               Dout_F                     ,
    input                               Dout_G                     ,
    input                               Dout_H                     ,
    input                               ad7606_firstdata           ,
    output reg                          ad7606_cs_n_o              ,
    output reg                          ad7606_rd_n_o              ,
    output reg         [   2: 0]        ad7606_os_o                ,
    output reg                          ad7606_convst_o            ,
    output reg                          ad7606_reset_o             ,
    output             [   2: 0]        ad7606_db2_0               ,
    output             [   3: 0]        ad7606_db15_12             ,
     (* MARK_DEBUG="true" *)output reg         [   7: 0]        data_flag                  ,
     (* MARK_DEBUG="true" *)output reg         [  15: 0]        data_1                     ,
     (* MARK_DEBUG="true" *)output reg         [  15: 0]        data_2                     ,
     (* MARK_DEBUG="true" *)output reg         [  15: 0]        data_3                     ,
     (* MARK_DEBUG="true" *)output reg         [  15: 0]        data_4                     ,
     (* MARK_DEBUG="true" *)output reg         [  15: 0]        data_5                     ,
     (* MARK_DEBUG="true" *)output reg         [  15: 0]        data_6                     ,
     (* MARK_DEBUG="true" *)output reg         [  15: 0]        data_7                     ,
     (* MARK_DEBUG="true" *)output reg         [  15: 0]        data_8                     ,
    output reg         [31:0]cnt_flag,
    output reg                          convst_done                ,
    output                              trig_test                  ,
    output                              sclk    
    );
    
    parameter                           DEVICE_SETUP               = 27400 ;
    parameter                           RESET                      = 320   ;

    reg                [  15: 0]        state                       ;
     //Ƶ
    reg                [   0: 0]        div_cnt                     ;
    reg                                 en                          ;
    reg                                 read_start                  ;
    reg                [  15: 0]        wait_cnt                    ;
    reg                [  24: 0]        cnt                         ;
    wire                                trig                        ;
    reg                [   5: 0]        cnt_table                   ;
    wire               [  15: 0]        lut                         ;
    reg                [  31: 0]        cnt_reset                   ;
    reg                [  31: 0]        cnt_setup                   ;
    reg                [  15: 0]        SDI_CONFIG                  ;   

    
    reg [15:0]data_a;
    reg [15:0]data_b;
    reg [15:0]data_c;
    reg [15:0]data_d;
    reg [15:0]data_e;
    reg [15:0]data_f;
    reg [15:0]data_g;
    reg [15:0]data_h;

    assign ad7606_db15_12 = 0;
    assign ad7606_db2_0 = 0;
    assign sclk = ad7606_rd_n_o;   
    
    parameter                           IDLE                       = 16'd0;
    parameter                           RESET_START                = 16'd1;
    parameter                           RESET_DEVICE_SETUP         = 16'd2;
    parameter                           WAIT_CS_N                  = 16'd3;
    parameter                           CONFIG_TABLE               = 16'd4;
    parameter                           CONFIG_CHECK               = 16'd5;
    parameter                           CONFIG_END                 = 16'd6; 
    parameter                           WORK_START                 = 16'd7; 
    parameter                           CONVST                     = 16'd8; 
    parameter                           BUSY_HIGHT                 = 16'd9; 
    parameter                           WAIT_BUSY_LOW              = 16'd10; 
    parameter                           PUll_DOWN_CS_N             = 16'd11; 
    parameter                           COV_ING                    = 16'd12; 
    parameter                           COV_END                    = 16'd13; 
    parameter                           END                        = 16'd14; 
    parameter                           WAIT                       = 16'd15;  
    parameter                           WAIT1                       = 16'd16;  
    
    parameter        WAIT2                             = 16'd17;
    parameter        COV_ING02                         = 16'd18;
    parameter        COV_ING_OTHER                     = 16'd19;
    parameter        CONFIG_END2                       = 16'd20;
    
    reg [31:0] ADC_SOFT_DATA_r;


    always @ (posedge Clk or negedge Reset_n)
    if (!Reset_n)
        en <= 0;
    else if (state == END)
        en <= 0;
    else if (read_start)
        en <= 1;
        
    always @ (posedge Clk or negedge Reset_n)
    if (!Reset_n)
        div_cnt <= 0;
    else if (en)
        div_cnt <= div_cnt + 1;
    else if (~en)
        div_cnt  <= 0;
        
     always@(posedge Clk or negedge Reset_n)
    if(!Reset_n)
        cnt <= 0;
    else if(cnt >= Speed_Set)
        cnt <= 0;
    else
        cnt <= cnt + 1'b1;
        
    reg                [  32: 0]        cov_data_cnt                ;        
    assign                              trig                        = cnt == Speed_Set;
    assign                              trig_test                   = trig;


    always @ (posedge Clk or negedge Reset_n)
    if (!Reset_n)begin
        ad7606_cs_n_o <= 1;
        ad7606_convst_o <= 1;
        read_start  <= 0;
        state <= IDLE;
        data_a <= 0;
        data_b <= 0;
        data_c <= 0;
        data_d <= 0;
        data_e <= 0;
        data_f <= 0;
        data_g <= 0;
        data_h <= 0;
        SDI <= 0;
        data_flag <= 8'b00000000;
        cnt_reset <= 0;
        cnt_setup <= 0;
        wait_cnt  <= 0;
        cnt_table <= 0;
        convst_done <= 0;
        cnt_flag <= 0;
        ADC_SOFT_DATA_r <= 0;
    end else case (state)
        IDLE : begin
            ad7606_cs_n_o <= 1;
            convst_done <= 0;
            cnt_table <= 0;
            cnt_flag <= 0;
            if (RestartReq)begin
                ADC_SOFT_DATA_r <= ADC_SOFT_DATA;
                if (ADC_SOFT_DATA[31:0] == 32'd0)begin
                    ad7606_os_o = 3'b111;           
                    state <= RESET_START;// ģʽʼĴ
                end else if(ADC_SOFT_DATA[31:0] != 32'd0)begin
                    ad7606_os_o = 3'b111;           
                    state <= WAIT_CS_N;// ģʽ޸ĵĴ
                end 
            end
        end
        
        RESET_START : begin
            cnt_reset <= cnt_reset + 1;
            ad7606_reset_o <= 1;
            ad7606_os_o <= 3'b111;
            if (cnt_reset >= RESET)
                state <= RESET_DEVICE_SETUP;
            else
                state <= RESET_START;
        end
        
        RESET_DEVICE_SETUP : begin
            cnt_setup <= cnt_setup + 1;
            ad7606_reset_o <= 0;
            ad7606_os_o <= 3'b111;
            if (cnt_setup >= DEVICE_SETUP)
                state <= WAIT_CS_N;
            else
                state <= RESET_DEVICE_SETUP;
        end
        
        
        WAIT_CS_N : begin
            ad7606_cs_n_o <= 0;
            read_start <= 1;
            if (ADC_SOFT_DATA[31:0] == 32'd0)
                state <= CONFIG_TABLE;
            else
                state <= COV_ING02;
        end
        
        
        COV_ING02 : begin
            SDI_CONFIG <= {2'b0,14'b00_0010_0001_1000};
            if (div_cnt == 0)begin
                wait_cnt <= wait_cnt + 1;
                case (wait_cnt)
                    0  : SDI <= SDI_CONFIG[15];
                    1  : SDI <= SDI_CONFIG[14];
                    2  : SDI <= SDI_CONFIG[13];
                    3  : SDI <= SDI_CONFIG[12];
                    4  : SDI <= SDI_CONFIG[11];
                    5  : SDI <= SDI_CONFIG[10];
                    6  : SDI <= SDI_CONFIG[9 ];
                    7  : SDI <= SDI_CONFIG[8 ];
                    8  : SDI <= SDI_CONFIG[7 ];
                    9  : SDI <= SDI_CONFIG[6 ];
                    10 : SDI <= SDI_CONFIG[5 ];
                    11 : SDI <= SDI_CONFIG[4 ];
                    12 : SDI <= SDI_CONFIG[3 ];
                    13 : SDI <= SDI_CONFIG[2 ];
                    14 : SDI <= SDI_CONFIG[1 ];
                    15 : SDI <= SDI_CONFIG[0 ];
                    default:;
                endcase
                if (wait_cnt == 15)begin
                    wait_cnt <= 0;
                    state <= WAIT2;
                end
            end
        end

        WAIT2 : begin
            read_start <= 1;
            state <= COV_ING_OTHER;
        end
        
        COV_ING_OTHER : begin
            SDI_CONFIG <= {2'b0,ADC_SOFT_DATA_r[29:16]};
            if (div_cnt == 0)begin
                wait_cnt <= wait_cnt + 1;
                case (wait_cnt)
                    0  : SDI <= SDI_CONFIG[15];
                    1  : SDI <= SDI_CONFIG[14];
                    2  : SDI <= SDI_CONFIG[13];
                    3  : SDI <= SDI_CONFIG[12];
                    4  : SDI <= SDI_CONFIG[11];
                    5  : SDI <= SDI_CONFIG[10];
                    6  : SDI <= SDI_CONFIG[9 ];
                    7  : SDI <= SDI_CONFIG[8 ];
                    8  : SDI <= SDI_CONFIG[7 ];
                    9  : SDI <= SDI_CONFIG[6 ];
                    10 : SDI <= SDI_CONFIG[5 ];
                    11 : SDI <= SDI_CONFIG[4 ];
                    12 : SDI <= SDI_CONFIG[3 ];
                    13 : SDI <= SDI_CONFIG[2 ];
                    14 : SDI <= SDI_CONFIG[1 ];
                    15 : SDI <= SDI_CONFIG[0 ];
                    default:;
                endcase
                if (wait_cnt == 15)begin
                    wait_cnt <= 0;
                    state <= CONFIG_END2;
                end
            end
        end
        
        CONFIG_END2 : begin
            state <= WAIT;    
        end

        
        CONFIG_TABLE : begin
            SDI_CONFIG <= {2'b0,lut[13:0]};
            if (div_cnt == 0)begin
                wait_cnt <= wait_cnt + 1;
                case (wait_cnt)
                    0  : SDI <= SDI_CONFIG[15];
                    1  : SDI <= SDI_CONFIG[14];
                    2  : SDI <= SDI_CONFIG[13];
                    3  : SDI <= SDI_CONFIG[12];
                    4  : SDI <= SDI_CONFIG[11];
                    5  : SDI <= SDI_CONFIG[10];
                    6  : SDI <= SDI_CONFIG[9 ];
                    7  : SDI <= SDI_CONFIG[8 ];
                    8  : SDI <= SDI_CONFIG[7 ];
                    9  : SDI <= SDI_CONFIG[6 ];
                    10 : SDI <= SDI_CONFIG[5 ];
                    11 : SDI <= SDI_CONFIG[4 ];
                    12 : SDI <= SDI_CONFIG[3 ];
                    13 : SDI <= SDI_CONFIG[2 ];
                    14 : SDI <= SDI_CONFIG[1 ];
                    15 : SDI <= SDI_CONFIG[0 ];
                    default:;
                endcase
                if (wait_cnt == 15)begin
                    wait_cnt <= 0;
                    state <= CONFIG_CHECK;
                    cnt_table <= cnt_table + 1;
                end
            end
        end
        
        CONFIG_CHECK : begin
            if (cnt_table < 40)
                state <= CONFIG_TABLE;
            else
                state <= CONFIG_END;
        end
        

        CONFIG_END : begin                               
            state <= WAIT;
        end
        
        WAIT : begin    //ADCģʽ
            if (div_cnt == 1)begin
                wait_cnt <= wait_cnt + 1;
                SDI <= 0;
                if (wait_cnt == 32)begin
                    wait_cnt <= 0;
                    state <= WORK_START;
                    read_start <= 0;
                    ad7606_cs_n_o <= 1;
                end
            end
        end

        WORK_START : begin
            ad7606_cs_n_o <= 1;
            ad7606_convst_o <= 1;
            convst_done <= 0;
            if (trig)
                state <= CONVST;
            else
                state <= WORK_START;
        end
        
        CONVST  :   begin
            if (wait_cnt == 1)begin
                ad7606_convst_o <= 1;
                state <= BUSY_HIGHT;
                wait_cnt <= 0;
            end else begin
                ad7606_convst_o <= 0;
                wait_cnt <= wait_cnt + 1;
            end
        end
        
        BUSY_HIGHT  :   begin
            if (wait_cnt == 1)begin
                wait_cnt <= 0;
                state <= WAIT_BUSY_LOW;
            end else begin
                wait_cnt <= wait_cnt + 1;
            end
        end
        
        
       WAIT_BUSY_LOW : begin
            if (ad7606_busy == 0)
                state <= PUll_DOWN_CS_N;
        end
        
        PUll_DOWN_CS_N : begin
            ad7606_cs_n_o <= 0;
            state <= WAIT1;
        end
        
        WAIT1 : begin
            read_start <= 1;
            state <= COV_ING;
        end

        
        COV_ING : begin
            if (div_cnt == 1)begin
                data_a <= {data_a[14:0],Dout_A};
                data_b <= {data_b[14:0],Dout_B};
                data_c <= {data_c[14:0],Dout_C};
                data_d <= {data_d[14:0],Dout_D};
                data_e <= {data_e[14:0],Dout_E};
                data_f <= {data_f[14:0],Dout_F};
                data_g <= {data_g[14:0],Dout_G};
                data_h <= {data_h[14:0],Dout_H};
                wait_cnt <= wait_cnt + 1;
                if (wait_cnt == 15)begin
                    wait_cnt <= 0;
                    data_flag <= 8'b11111111;
                    cnt_flag <= cnt_flag + 1;
                    state  <= COV_END;
                    convst_done <= 1;
                end
            end
        end
    
        COV_END :begin
            data_flag <= 8'b00000000;
            ad7606_cs_n_o <= 1;
            convst_done <= 0;
            if (cov_data_cnt <= DataNum * 2)
                state <= WORK_START;
            else
                state <= IDLE;
        end

        
        default:begin state <=  IDLE;convst_done <= 0;ad7606_cs_n_o <= 1;ad7606_convst_o <= 1;ad7606_reset_o <= 0;
                    cnt_table <= 6'd0;
                    cnt_reset <= 32'd0;
                    cnt_setup <= 32'd0;
                    ad7606_os_o = 3'b000;
                    read_start  <= 0;
                    data_a <= 0;
                    data_b <= 0;
                    data_c <= 0;
                    data_d <= 0;
                    data_e <= 0;
                    data_f <= 0;
                    data_g <= 0;
                    data_h <= 0;
        end
    endcase
    
    always @ (posedge Clk or negedge Reset_n)
    if (!Reset_n)
        cov_data_cnt <= 0;
    else if (state == IDLE)
        cov_data_cnt <= 0;
    else if (convst_done)
        cov_data_cnt <= cov_data_cnt + 1;
    else
        cov_data_cnt <= cov_data_cnt;   

    always @ (posedge Clk or negedge Reset_n)
    if (!Reset_n)
        ad7606_rd_n_o <= 1;
    else case (state)
        IDLE : ad7606_rd_n_o <= 1;
        RESET_START : ad7606_rd_n_o <= 1;
        RESET_DEVICE_SETUP : ad7606_rd_n_o <= 1;
        CONFIG_TABLE : if (div_cnt == 0)  ad7606_rd_n_o <= 0; else  ad7606_rd_n_o <= 1;
        CONFIG_CHECK : ad7606_rd_n_o <= 1;
        CONFIG_END : ad7606_rd_n_o <= 1;
        
        COV_ING02 : if (div_cnt == 0)  ad7606_rd_n_o <= 0; else  ad7606_rd_n_o <= 1;
        COV_ING_OTHER : if (div_cnt == 0)  ad7606_rd_n_o <= 0; else  ad7606_rd_n_o <= 1;
        CONFIG_END2 : ad7606_rd_n_o <= 1;    

        WAIT : if (div_cnt == 0 )  ad7606_rd_n_o <= 0; else  ad7606_rd_n_o <= 1;

        WORK_START : ad7606_rd_n_o <= 1;
        CONVST : ad7606_rd_n_o <= 1;
        BUSY_HIGHT : ad7606_rd_n_o <= 1;
        WAIT_BUSY_LOW : ad7606_rd_n_o <= 1;
        WAIT1 : if (div_cnt == 0 )  ad7606_rd_n_o <= 0; else  ad7606_rd_n_o <= 1;
        COV_ING: if (div_cnt == 0)  ad7606_rd_n_o <= 0; else  ad7606_rd_n_o <= 1;
        COV_END : ad7606_rd_n_o <= 1;
        END : ad7606_rd_n_o <= 1;
    endcase
    
    always @ (posedge Clk or negedge Reset_n)
    if (!Reset_n)
        data_1 <= 0;
    else if (data_flag[0])
        data_1 <= data_a; 
         
    always @ (posedge Clk or negedge Reset_n)
    if (!Reset_n)
        data_2 <= 0;
    else if (data_flag[1] ) 
        data_2 <= data_b;
        
    always @ (posedge Clk or negedge Reset_n)
    if (!Reset_n)
        data_3 <= 0;
    else if (data_flag[2] )
        data_3 <= data_c;
        
    always @ (posedge Clk or negedge Reset_n)
    if (!Reset_n)
        data_4 <=0;
    else if (data_flag[3] )
        data_4 <= data_d;
        
    always @ (posedge Clk or negedge Reset_n)
    if (!Reset_n)
        data_5 <= 0;
    else if (data_flag[4] )
        data_5 <= data_e;
        
    always @ (posedge Clk or negedge Reset_n)
    if (!Reset_n)
        data_6 <= data_6;
    else if (data_flag[5] )
        data_6 <= data_f;
        
    always @ (posedge Clk or negedge Reset_n)
    if (!Reset_n)
        data_7 <= 0;
    else if (data_flag[6] )
        data_7 <= data_g;
        
    always @ (posedge Clk or negedge Reset_n)
    if (!Reset_n)
        data_8 <= 0;
    else if (data_flag[7])
        data_8 <= data_h;


ad7606c_init_table   ad7606c_init_table(
    .clk                                (Clk                       ),
    .addr                               (cnt_table                 ),
    .data                               (lut                       ) 
);      
                
endmodule
