`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2025/04/03 15:04:11
// Design Name: 
// Module Name: data2ddr
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module data2ddr(
    input                               Clk                        ,
    input                               Reset_n                    ,
    input              [   3: 0]        SKIP_SAMPLES               ,
    input              [  31: 0]        DataNum                    ,//βɼݸ󲻳FIFO
    input                               RestartReq                 ,//ʼź
    input              [   7: 0]        ChannelSel                 ,//Ҫͨѡ  ÿһλӦһͨĿ
    output reg                          fifowrreq                  ,//ɼдFIFOź
    output reg         [  15: 0]        fifowrdata                 ,//FIFOɼ
    input                               sample_en                  ,
    input              [   7: 0]        adc_data_flag              ,
    input              [  15: 0]        data_1                     ,
    input              [  15: 0]        data_2                     ,
    input              [  15: 0]        data_3                     ,
    input              [  15: 0]        data_4                     ,
    input              [  15: 0]        data_5                     ,
    input              [  15: 0]        data_6                     ,
    input              [  15: 0]        data_7                     ,
    input              [  15: 0]        data_8                      
    );

    reg                [   2: 0]        channel_index               ;// ǰͨ
    reg                [   7: 0]        channel_mask                ;// ¼ǰ `ChannelSel` ѡеͨ
    reg [1:0] skip_cnt;
    always @(posedge Clk or negedge Reset_n) begin
    if (!Reset_n)
        skip_cnt <= 2'd0;
    else if (RestartReq)
        skip_cnt <= 2'd0;
    else if (sample_en && (adc_data_flag & ChannelSel) && skip_cnt < SKIP_SAMPLES)
        skip_cnt <= skip_cnt + 1;
    end
   // ¼ `ChannelSel` ѡеͨ
    always @(posedge Clk or negedge Reset_n) begin
        if (!Reset_n)
            channel_mask <= 8'b0;
        else if (RestartReq)
            channel_mask <= ChannelSel;
    end
    
    reg RestartReq_d1,RestartReq_d2;
    
    always @ (posedge Clk)begin
        RestartReq_d1 <= RestartReq;
        RestartReq_d2 <= RestartReq_d1;
    end
    
    
always @(posedge Clk or negedge Reset_n) begin
    if (!Reset_n)
        channel_index <= 3'd0;
    else if (channel_mask != ChannelSel)
        channel_index <= 3'd0;
    else if (RestartReq_d2) begin
        //  ChannelSel ǷЧͨ
        if ((ChannelSel[6] == 1'b0) && (ChannelSel[5] == 1'b0)&&(ChannelSel[4] == 1'b0) && (ChannelSel[3] == 1'b0)&&(ChannelSel[2] == 1'b0) && (ChannelSel[1] == 1'b0)&& (ChannelSel[0] == 1'b0)) begin
            channel_index <= (
                              channel_mask[7] ? 3'd7 : 3'd7);  // ûЧͨ 3'd2
        end

        else if ((ChannelSel[5] == 1'b0)&&(ChannelSel[4] == 1'b0) && (ChannelSel[3] == 1'b0)&&(ChannelSel[2] == 1'b0) && (ChannelSel[1] == 1'b0)&& (ChannelSel[0] == 1'b0))begin
            channel_index <= (channel_mask[6] ? 3'd6 :
                              channel_mask[7] ? 3'd7 : 3'd6);  // ûЧͨ 3'd1
        end

        else if ((ChannelSel[4] == 1'b0) && (ChannelSel[3] == 1'b0)&&(ChannelSel[2] == 1'b0) && (ChannelSel[1] == 1'b0)&& (ChannelSel[0] == 1'b0))begin
            channel_index <= (
                              channel_mask[5] ? 3'd5 :
                              channel_mask[6] ? 3'd6 :
                              channel_mask[7] ? 3'd7 : 3'd5);  // ûЧͨ 3'd1
        end
        
        else if ((ChannelSel[3] == 1'b0) &&(ChannelSel[2] == 1'b0) && (ChannelSel[1] == 1'b0)&& (ChannelSel[0] == 1'b0))begin
            channel_index <= (
                              channel_mask[4] ? 3'd4 :
                              channel_mask[5] ? 3'd5 :
                              channel_mask[6] ? 3'd6 :
                              channel_mask[7] ? 3'd7 : 3'd4);  // ûЧͨ 3'd1
        end        
        
        else if ((ChannelSel[2] == 1'b0) && (ChannelSel[1] == 1'b0)&& (ChannelSel[0] == 1'b0))begin
            channel_index <= (
                              channel_mask[3] ? 3'd3 :
                              channel_mask[4] ? 3'd4 :
                              channel_mask[5] ? 3'd5 :
                              channel_mask[6] ? 3'd6 :
                              channel_mask[7] ? 3'd7 : 3'd3);  // ûЧͨ 3'd1
        end           
        
        else if ((ChannelSel[1] == 1'b0)&& (ChannelSel[0] == 1'b0))begin
            channel_index <= (
                              channel_mask[2] ? 3'd2 :
                              channel_mask[3] ? 3'd3 :
                              channel_mask[4] ? 3'd4 :
                              channel_mask[5] ? 3'd5 :
                              channel_mask[6] ? 3'd6 :
                              channel_mask[7] ? 3'd7 : 3'd2);  // ûЧͨ 3'd1
        end          

         else if ( (ChannelSel[0] == 1'b0))begin
            channel_index <= (channel_mask[1] ? 3'd1 :
                              channel_mask[2] ? 3'd2 :
                              channel_mask[3] ? 3'd3 :
                              channel_mask[4] ? 3'd4 :
                              channel_mask[5] ? 3'd5 :
                              channel_mask[6] ? 3'd6 :
                              channel_mask[7] ? 3'd7 : 3'd1);  // ûЧͨ 3'd1
        end

        else begin
            // `ChannelSel[0]` ʱѡͨ
            channel_index <= (channel_mask[0] ? 3'd0 :
                              channel_mask[1] ? 3'd1 :
                              channel_mask[2] ? 3'd2 :
                              channel_mask[3] ? 3'd3 :
                              channel_mask[4] ? 3'd4 :
                              channel_mask[5] ? 3'd5 :
                              channel_mask[6] ? 3'd6 :
                              channel_mask[7] ? 3'd7 : 3'd0);
        end
    end else if (fifowrreq) begin
        if ((channel_mask[6] == 1'b0) && (channel_mask[5] == 1'b0)&&(channel_mask[4] == 1'b0) && (channel_mask[3] == 1'b0)&&(channel_mask[2] == 1'b0) && (channel_mask[1] == 1'b0)&& (channel_mask[0] == 1'b0))begin
            case (channel_index)
                3'd7: channel_index <= 3'd7;
                default : channel_index <= 3'd7;
            endcase
        end else if ((channel_mask[5] == 1'b0)&&(channel_mask[4] == 1'b0) && (channel_mask[3] == 1'b0)&&(channel_mask[2] == 1'b0) && (channel_mask[1] == 1'b0)&& (channel_mask[0] == 1'b0))begin
            case(channel_index)
                3'd6: channel_index <= (channel_mask[7] ? 3'd7 : 3'd6);
                3'd7: channel_index <= 3'd6;
                default : channel_index <= 3'd6;
            endcase
        end else if ((channel_mask[4] == 1'b0) && (channel_mask[3] == 1'b0)&&(channel_mask[2] == 1'b0) && (channel_mask[1] == 1'b0)&& (channel_mask[0] == 1'b0))begin
            case(channel_index)
                3'd5: channel_index <= (channel_mask[6] ? 3'd6 :
                                        channel_mask[7] ? 3'd7 : 3'd5);
                3'd6: channel_index <= (channel_mask[7] ? 3'd7 : 3'd5);
                3'd7: channel_index <= 3'd5;
                default : channel_index <= 3'd5;
            endcase
        end else if ( (channel_mask[3] == 1'b0)&&(channel_mask[2] == 1'b0) && (channel_mask[1] == 1'b0)&& (channel_mask[0] == 1'b0))begin
            case(channel_index)
                3'd4: channel_index <= (channel_mask[5] ? 3'd5 :
                                        channel_mask[6] ? 3'd6 :
                                        channel_mask[7] ? 3'd7 : 3'd4);
                3'd5: channel_index <= (channel_mask[6] ? 3'd6 :
                                        channel_mask[7] ? 3'd7 : 3'd4);
                3'd6: channel_index <= (channel_mask[7] ? 3'd7 : 3'd4);
                3'd7: channel_index <= 3'd4;
                default : channel_index <= 3'd4;
            endcase
        end 

        else if ((channel_mask[2] == 1'b0) && (channel_mask[1] == 1'b0)&& (channel_mask[0] == 1'b0))begin
            case(channel_index)
                3'd3: channel_index <= (channel_mask[4] ? 3'd4 :
                                        channel_mask[5] ? 3'd5 :
                                        channel_mask[6] ? 3'd6 :
                                        channel_mask[7] ? 3'd7 : 3'd3);
                3'd4: channel_index <= (channel_mask[5] ? 3'd5 :
                                        channel_mask[6] ? 3'd6 :
                                        channel_mask[7] ? 3'd7 : 3'd3);
                3'd5: channel_index <= (channel_mask[6] ? 3'd6 :
                                        channel_mask[7] ? 3'd7 : 3'd3);
                3'd6: channel_index <= (channel_mask[7] ? 3'd7 : 3'd3);
                3'd7: channel_index <= 3'd3;
                default : channel_index <= 3'd3;
            endcase
        end else if((channel_mask[1] == 1'b0) && (channel_mask[0] == 1'b0))begin
            case (channel_index)
            3'd2: channel_index <= (channel_mask[3] ? 3'd3 :
                                    channel_mask[4] ? 3'd4 :
                                    channel_mask[5] ? 3'd5 :
                                    channel_mask[6] ? 3'd6 :
                                    channel_mask[7] ? 3'd7 : 3'd2);
            3'd3: channel_index <= (channel_mask[4] ? 3'd4 :
                                    channel_mask[5] ? 3'd5 :
                                    channel_mask[6] ? 3'd6 :
                                    channel_mask[7] ? 3'd7 : 3'd2);
            3'd4: channel_index <= (channel_mask[5] ? 3'd5 :
                                    channel_mask[6] ? 3'd6 :
                                    channel_mask[7] ? 3'd7 : 3'd2);
            3'd5: channel_index <= (channel_mask[6] ? 3'd6 :
                                    channel_mask[7] ? 3'd7 : 3'd2);
            3'd6: channel_index <= (channel_mask[7] ? 3'd7 : 3'd2);
            3'd7: channel_index <= 3'd2;
            default : channel_index <= 3'd2;
            
        endcase
        end else if ((channel_mask[0] == 1'b0))begin
            case (channel_index)
            3'd1: channel_index <= (channel_mask[2] ? 3'd2 :
                                    channel_mask[3] ? 3'd3 :
                                    channel_mask[4] ? 3'd4 :
                                    channel_mask[5] ? 3'd5 :
                                    channel_mask[6] ? 3'd6 :
                                    channel_mask[7] ? 3'd7 : 3'd1);
            3'd2: channel_index <= (channel_mask[3] ? 3'd3 :
                                    channel_mask[4] ? 3'd4 :
                                    channel_mask[5] ? 3'd5 :
                                    channel_mask[6] ? 3'd6 :
                                    channel_mask[7] ? 3'd7 : 3'd1);
            3'd3: channel_index <= (channel_mask[4] ? 3'd4 :
                                    channel_mask[5] ? 3'd5 :
                                    channel_mask[6] ? 3'd6 :
                                    channel_mask[7] ? 3'd7 : 3'd1);
            3'd4: channel_index <= (channel_mask[5] ? 3'd5 :
                                    channel_mask[6] ? 3'd6 :
                                    channel_mask[7] ? 3'd7 : 3'd1);
            3'd5: channel_index <= (channel_mask[6] ? 3'd6 :
                                    channel_mask[7] ? 3'd7 : 3'd1);
            3'd6: channel_index <= (channel_mask[7] ? 3'd7 : 3'd1);
            3'd7: channel_index <= 3'd1;
            default : channel_index <= 3'd1;
            endcase
        end
        else begin
        case (channel_index)
            3'd0: channel_index <= (channel_mask[1] ? 3'd1 :
                                    channel_mask[2] ? 3'd2 :
                                    channel_mask[3] ? 3'd3 :
                                    channel_mask[4] ? 3'd4 :
                                    channel_mask[5] ? 3'd5 :
                                    channel_mask[6] ? 3'd6 :
                                    channel_mask[7] ? 3'd7 : 3'd0);
            3'd1: channel_index <= (channel_mask[2] ? 3'd2 :
                                    channel_mask[3] ? 3'd3 :
                                    channel_mask[4] ? 3'd4 :
                                    channel_mask[5] ? 3'd5 :
                                    channel_mask[6] ? 3'd6 :
                                    channel_mask[7] ? 3'd7 : 3'd0);
            3'd2: channel_index <= (channel_mask[3] ? 3'd3 :
                                    channel_mask[4] ? 3'd4 :
                                    channel_mask[5] ? 3'd5 :
                                    channel_mask[6] ? 3'd6 :
                                    channel_mask[7] ? 3'd7 : 3'd0);
            3'd3: channel_index <= (channel_mask[4] ? 3'd4 :
                                    channel_mask[5] ? 3'd5 :
                                    channel_mask[6] ? 3'd6 :
                                    channel_mask[7] ? 3'd7 : 3'd0);
            3'd4: channel_index <= (channel_mask[5] ? 3'd5 :
                                    channel_mask[6] ? 3'd6 :
                                    channel_mask[7] ? 3'd7 : 3'd0);
            3'd5: channel_index <= (channel_mask[6] ? 3'd6 :
                                    channel_mask[7] ? 3'd7 : 3'd0);
            3'd6: channel_index <= (channel_mask[7] ? 3'd7 : 3'd0);
            3'd7: channel_index <= 3'd0;
            default : channel_index <= 3'd7;
        endcase        
        end
    end
end


    always @(posedge Clk) begin
        fifowrreq <= (adc_data_flag & ChannelSel) && sample_en && (skip_cnt >= SKIP_SAMPLES);
     end



    always @(posedge Clk) begin
        case (channel_index)
            3'd0: fifowrdata <= data_1;
            3'd1: fifowrdata <= data_2;
            3'd2: fifowrdata <= data_3;
            3'd3: fifowrdata <= data_4;
            3'd4: fifowrdata <= data_5;
            3'd5: fifowrdata <= data_6;
            3'd6: fifowrdata <= data_7;
            3'd7: fifowrdata <= data_8;
            default: fifowrdata <= 16'd0;
        endcase
    end
    

endmodule
