`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2025/04/21 13:53:09
// Design Name: 
// Module Name: top
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module top(
    input                               ad7606_busy                ,
    input                               Dout_A                     ,
    input                               Dout_B                     ,
    input                               Dout_C                     ,
    input                               Dout_D                     ,
    input                               Dout_E                     ,
    input                               Dout_F                     ,
    input                               Dout_G                     ,
    input                               Dout_H                     ,
    output                              SDI                        ,
    input                               ad7606_firstdata           ,
    output                              ad7606_cs_n_o              ,
    output                              ad7606_rd_n_o              ,
    output             [   2: 0]        ad7606_os_o                ,
    output                              ad7606_convst_o            ,
    output                              ad7606_reset_o             ,
    output             [   2: 0]        ad7606_db2_0               ,
    output             [   3: 0]        ad7606_db15_12             ,
    
      //eth_reset
  output          eth_reset,
  //eth_rx
  input           rgmii_rx_clk_i   ,
  input  [3:0]    rgmii_rxd        ,
  input           rgmii_rxdv       ,
  //eth_tx
  output          rgmii_tx_clk     ,
  output  [3:0]   rgmii_txd        ,
  output          rgmii_txen       ,
  //LED
  output          led              ,
  input           reset_n          ,
  
   //DDR3 Interface
  // Inouts
  inout  [31:0]   ddr3_dq          ,
  inout  [3:0]    ddr3_dqs_n       ,
  inout  [3:0]    ddr3_dqs_p       ,
  // Outputs      
  output [14:0]   ddr3_addr        ,
  output [2:0]    ddr3_ba          ,
  output          ddr3_ras_n       ,
  output          ddr3_cas_n       ,
  output          ddr3_we_n        ,
  output          ddr3_reset_n     ,
  output [0:0]    ddr3_ck_p        ,
  output [0:0]    ddr3_ck_n        ,
  output [0:0]    ddr3_cke         ,
  output [0:0]    ddr3_cs_n        ,
  output [3:0]    ddr3_dm          ,
  output [0:0]    ddr3_odt         ,
  inout           FIXED_IO_ddr_vrn ,
  inout           FIXED_IO_ddr_vrp ,
  inout [53:0]    FIXED_IO_mio     ,
  inout           FIXED_IO_ps_clk  ,
  inout           FIXED_IO_ps_porb ,
  inout           FIXED_IO_ps_srstb 
  
);
    wire rgmii_rx_clk;
    MMCM MMCM(
    .clk_out1                           (rgmii_rx_clk              ),// output clk_out1
    .clk_in1                            (rgmii_rx_clk_i)             // input clk_in1
    );
  //axi
  wire [3:0]    s_axi_awid;
  wire [31:0]   s_axi_awaddr;
  wire [7:0]    s_axi_awlen;
  wire [2:0]    s_axi_awsize;
  wire [1:0]    s_axi_awburst;
  wire [0:0]    s_axi_awlock;
  wire [3:0]    s_axi_awcache;
  wire [2:0]    s_axi_awprot;
  wire [3:0]    s_axi_awqos;
  wire [3:0]    s_axi_awregion;
  wire          s_axi_awvalid;
  wire          s_axi_awready;
  //
  wire [63:0]   s_axi_wdata;
  wire [7:0]    s_axi_wstrb;
  wire          s_axi_wlast;
  wire          s_axi_wvalid;
  wire          s_axi_wready;
  //
  wire [3:0]    s_axi_bid;
  wire [1:0]    s_axi_bresp;
  wire          s_axi_bvalid;
  wire          s_axi_bready;
  //
  wire [3:0]    s_axi_arid;
  wire [31:0]   s_axi_araddr;
  wire [7:0]    s_axi_arlen;
  wire [2:0]    s_axi_arsize;
  wire [1:0]    s_axi_arburst;
  wire [0:0]    s_axi_arlock;
  wire [3:0]    s_axi_arcache;
  wire [2:0]    s_axi_arprot;
  wire [3:0]    s_axi_arqos;
  wire [3:0]    s_axi_arregion;
  wire          s_axi_arvalid;
  wire          s_axi_arready;
  //
  wire [3:0]    s_axi_rid;
  wire [63:0]   s_axi_rdata;
  wire [1:0]    s_axi_rresp;
  wire          s_axi_rlast;
  wire          s_axi_rvalid;
  wire          s_axi_rready;
  //
  wire          s_axi_aclk;
  wire          s_axi_resetn;
  
    wire          ps2pl_clk50m_0; //ϵͳʱ룬50MHz
  wire          ps2pl_resetn_0; //λź
//PLʹDDRĻַһռPS
parameter DDR_BASE_ADDR = 32'h18000000;

bd_wrapper  bd_wrapper(
    .DDR_0_addr(ddr3_addr),
    .DDR_0_ba(ddr3_ba),
    .DDR_0_cas_n(ddr3_cas_n),
    .DDR_0_ck_n(ddr3_ck_n),
    .DDR_0_ck_p(ddr3_ck_p),
    .DDR_0_cke(ddr3_cke),
    .DDR_0_cs_n(ddr3_cs_n),
    .DDR_0_dm(ddr3_dm),
    .DDR_0_dq(ddr3_dq),
    .DDR_0_dqs_n(ddr3_dqs_n),
    .DDR_0_dqs_p(ddr3_dqs_p),
    .DDR_0_odt(ddr3_odt),
    .DDR_0_ras_n(ddr3_ras_n),
    .DDR_0_reset_n(ddr3_reset_n),
    .DDR_0_we_n(ddr3_we_n),
    .FIXED_IO_0_ddr_vrn(FIXED_IO_ddr_vrn),
    .FIXED_IO_0_ddr_vrp(FIXED_IO_ddr_vrp),
    .FIXED_IO_0_mio(FIXED_IO_mio),
    .FIXED_IO_0_ps_clk(FIXED_IO_ps_clk),
    .FIXED_IO_0_ps_porb(FIXED_IO_ps_porb),
    .FIXED_IO_0_ps_srstb(FIXED_IO_ps_srstb),
    .pl2ps_axi_0_araddr(s_axi_araddr),
    .pl2ps_axi_0_arburst(s_axi_arburst),
    .pl2ps_axi_0_arcache(s_axi_arcache),
    .pl2ps_axi_0_arid(),
    .pl2ps_axi_0_arlen(s_axi_arlen),
    .pl2ps_axi_0_arlock(s_axi_arlock),
    .pl2ps_axi_0_arprot(s_axi_arprot),
    .pl2ps_axi_0_arqos(s_axi_arqos),
    .pl2ps_axi_0_arready(s_axi_arready),
    .pl2ps_axi_0_arsize(s_axi_arsize),
    .pl2ps_axi_0_arvalid(s_axi_arvalid),
    .pl2ps_axi_0_awaddr(s_axi_awaddr),
    .pl2ps_axi_0_awburst(s_axi_awburst),
    .pl2ps_axi_0_awcache(s_axi_awcache),
    .pl2ps_axi_0_awid(),
    .pl2ps_axi_0_awlen(s_axi_awlen),
    .pl2ps_axi_0_awlock(s_axi_awlock),
    .pl2ps_axi_0_awprot(s_axi_awprot),
    .pl2ps_axi_0_awqos(s_axi_awqos),
    .pl2ps_axi_0_awready(s_axi_awready),
    .pl2ps_axi_0_awsize(s_axi_awsize),
    .pl2ps_axi_0_awvalid(s_axi_awvalid),
    .pl2ps_axi_0_bid(),
    .pl2ps_axi_0_bready(s_axi_bready),
    .pl2ps_axi_0_bresp(s_axi_bresp),
    .pl2ps_axi_0_bvalid(s_axi_bvalid),
    .pl2ps_axi_0_rdata(s_axi_rdata),
    .pl2ps_axi_0_rid(),
    .pl2ps_axi_0_rlast(s_axi_rlast),
    .pl2ps_axi_0_rready(s_axi_rready),
    .pl2ps_axi_0_rresp(s_axi_rresp),
    .pl2ps_axi_0_rvalid(s_axi_rvalid),
    .pl2ps_axi_0_wdata(s_axi_wdata),
    .pl2ps_axi_0_wid(),
    .pl2ps_axi_0_wlast(s_axi_wlast),
    .pl2ps_axi_0_wready(s_axi_wready),
    .pl2ps_axi_0_wstrb(s_axi_wstrb),
    .pl2ps_axi_0_wvalid(s_axi_wvalid),
    .pl2ps_axi_aclk_0(s_axi_aclk),
    .pl2ps_axi_resetn_0(s_axi_resetn),
    .ps2pl_clk50m_0(ps2pl_clk50m_0),
    .ps2pl_resetn_0(ps2pl_resetn_0)
    );

     
    wire pll_locked;
    wire pl_reset_n;
    wire loc_clk100m;
    wire reset_pre;
      pll pll
  (
    // Clock out ports
    .clk_out1 (loc_clk100m     ), // output clk_out1
    // Status and control signals
    .resetn   (pl_reset_n), // input reset
    .locked   (pll_locked      ), // output locked
    // Clock in ports
    .clk_in1  (ps2pl_clk50m_0  )  // input clk_in1
  );
  assign eth_reset = 'b1;
  assign led = {pll_locked};
  assign pl_reset_n = ps2pl_resetn_0 & reset_n;
  assign reset_pre     = ~pll_locked;
  reg [19:0] reset_sync;
  wire reset;
    assign s_axi_aclk        = loc_clk100m;
  assign s_axi_resetn      = pll_locked;
  //PSͷŸλPL߼λͷӳ20ʱ
  always@(posedge loc_clk100m or posedge reset_pre)
  begin
    if(reset_pre)
      reset_sync <= {20{1'b1}};
    else
      reset_sync <= reset_sync << 1;
  end

  assign reset = reset_sync[19];  
  
  parameter local_mac = 48'h00_0a_35_01_fe_c0;
  parameter local_ip = 32'hc0_a8_00_02;
  parameter local_port = 16'd5000;
    wire                                gmii_rx_clk                 ;
    wire               [   7: 0]        gmii_rxd                    ;
    wire                                gmii_rxdv                   ;
    rgmii_to_gmii rgmii_to_gmii(
    .reset                              (reset                   ),
      
    .rgmii_rx_clk                       (rgmii_rx_clk              ),
    .rgmii_rxd                          (rgmii_rxd                 ),
    .rgmii_rxdv                         (rgmii_rxdv                ),
      
    .gmii_rx_clk                        (gmii_rx_clk               ),
    .gmii_rxdv                          (gmii_rxdv                 ),
    .gmii_rxd                           (gmii_rxd                  ),
    .gmii_rxer                          (                          ) 
    );
    wire clk125m_o;
    wire payload_valid_o;
    wire [7:0]payload_dat_o;
    wire one_pkt_done;
       //̫
    eth_udp_rx_gmii eth_udp_rx_gmii(
    .reset_p                            (reset                   ),
   
    .local_mac                          (local_mac                 ),
    .local_ip                           (local_ip                  ),
    .local_port                         (local_port                ),
   
    .clk125m_o                          (clk125m_o                 ),
    .exter_mac                          (                          ),
    .exter_ip                           (                          ),
    .exter_port                         (                          ),
    .rx_data_length                     (                          ),
    .data_overflow_i                    (                          ),
    .payload_valid_o                    (payload_valid_o           ),
    .payload_dat_o                      (payload_dat_o             ),
   
    .one_pkt_done                       (one_pkt_done              ),
    .pkt_error                          (                          ),
    .debug_crc_check                    (                          ),
   
    .gmii_rx_clk                        (gmii_rx_clk               ),
    .gmii_rxdv                          (gmii_rxdv                 ),
    .gmii_rxd                           (gmii_rxd                  ) 
    );
 
 wire fifo_rd_req;
 wire [7:0]rxdout;
 wire rx_empty;
    fifo_rx fifo_rx (
    .rst                                (!reset_n                  ),// input wire rst
    .wr_clk                             (clk125m_o                 ),// input wire wr_clk
    .rd_clk                             (loc_clk100m                       ),// input wire rd_clk
    .din                                (payload_dat_o             ),// input wire [7 : 0] din
    .wr_en                              (payload_valid_o           ),// input wire wr_en
    .rd_en                              (fifo_rd_req               ),// input wire rd_en
    .dout                               (rxdout                    ),// output wire [7 : 0] dout
    .full                               (                          ),// output wire full
    .empty                              (rx_empty                  ) // output wire empty
          );
   wire                                cmdvalid_0                  ;
    wire               [   7: 0]        address_0                   ;
   wire               [  31: 0]        cmd_data_0                  ;          
     eth_cmd eth_cmd (
    .clk                                (loc_clk100m                       ),
    .reset_n                            (reset_n                   ),
    .fifo_rd_req                        (fifo_rd_req               ),
    .rx_empty                           (rx_empty                  ),
    .fifodout                           (rxdout                    ),
    .cmdvalid                           (cmdvalid_0                ),
    .address                            (address_0                 ),
    .cmd_data                           (cmd_data_0                ) 
   );         
     
   wire [31:0]ADC_SOFT_DATA;  
   wire               [  31: 0]        DataNum                     ;
   wire                                RestartReq                  ;
   wire               [   7: 0]        ChannelSel                  ;
   wire               [  31: 0]        ADC_Speed_Set               ;      
    cmd_rx cmd_rx_0(
    .clk                                (loc_clk100m                       ),
    .reset_n                            (reset_n                   ),
    .cmdvalid                           (cmdvalid_0                ),
    .cmd_addr                           (address_0                 ),
    .cmd_data                           (cmd_data_0                ),
	.ADC_SOFT_DATA(ADC_SOFT_DATA),	
    .ChannelSel                         (ChannelSel                ),
    .DataNum                            (DataNum                   ),
    .ADC_Speed_Set                      (ADC_Speed_Set             ),
    .RestartReq                         (RestartReq                ) 
    );
    
    reg                [  31: 0]        Number_d0,Number_d1         ;
    reg  [31:0]                               ADC_SOFT_DATA_d0,ADC_SOFT_DATA_d1  ;
       reg RestartReq_0_d0,RestartReq_0_d1;
     always@(posedge clk125m_o)
     begin
        Number_d0 <= DataNum;
        Number_d1 <= Number_d0;
		
        RestartReq_0_d0 <= RestartReq;
        RestartReq_0_d1 <= RestartReq_0_d0;
               
        ADC_SOFT_DATA_d0 <= ADC_SOFT_DATA;
        ADC_SOFT_DATA_d1 <= ADC_SOFT_DATA_d0;
     end
     
       reg RestartReq_d1 ,RestartReq_d2;

       always @ (posedge clk125m_o)begin
           RestartReq_d1 <= RestartReq;
           RestartReq_d2 <= RestartReq_d1;
       end

       
    wire               [   7: 0]        data_flag                   ;
    wire               [  15: 0]        ad_ch1                      ;
    wire               [  15: 0]        ad_ch2                      ;
    wire               [  15: 0]        ad_ch3                      ;
    wire               [  15: 0]        ad_ch4                      ;
    wire               [  15: 0]        ad_ch5                      ;
    wire               [  15: 0]        ad_ch6                      ;
    wire               [  15: 0]        ad_ch7                      ;
    wire               [  15: 0]        ad_ch8                      ;
ad7606c_spi_software_mode_driver2  ad7606c_spi_software_mode_driver(
    .Clk                                (loc_clk100m                       ),
    .Reset_n                            (reset_n                   ),
    .DataNum                            (DataNum                   ),
    .Speed_Set                          (ADC_Speed_Set             ),
    .RestartReq                         (RestartReq             ),
    .ADC_SOFT_DATA                      (ADC_SOFT_DATA_d1             ),
    .SDI                                (SDI                       ),
    .ad7606_busy                        (ad7606_busy               ),
    .Dout_A                             (Dout_A                    ),
    .Dout_B                             (Dout_B                    ),
    .Dout_C                             (Dout_C                    ),
    .Dout_D                             (Dout_D                    ),
    .Dout_E                             (Dout_E                    ),
    .Dout_F                             (Dout_F                    ),
    .Dout_G                             (Dout_G                    ),
    .Dout_H                             (Dout_H                    ),
    .ad7606_firstdata                   (ad7606_firstdata          ),
    .ad7606_cs_n_o                      (ad7606_cs_n_o             ),
    .ad7606_rd_n_o                      (ad7606_rd_n_o             ),
    .ad7606_os_o                        (ad7606_os_o               ),
    .ad7606_convst_o                    (ad7606_convst_o           ),
    .ad7606_reset_o                     (ad7606_reset_o            ),
    .ad7606_db2_0                       (ad7606_db2_0              ),
    .ad7606_db15_12                     (ad7606_db15_12            ),
    .data_flag                          (data_flag                 ),
    .data_1                             (ad_ch1                    ),
    .data_2                             (ad_ch2                    ),
    .data_3                             (ad_ch3                    ),
    .data_4                             (ad_ch4                    ),
    .data_5                             (ad_ch5                    ),
    .data_6                             (ad_ch6                    ),
    .data_7                             (ad_ch7                    ),
    .data_8                             (ad_ch8                    ),
    .convst_done                        (                          ),
    .trig_test                          (                 ),
    .sclk                               (                          ) 
);

parameter SKIP_SAMPLES = 3;
wire ad_sample_en;
wire fifowrreq;
wire [15:0] fifowrdata;

    data2ddr  data2ddr(
    .Clk                                (loc_clk100m                       ),
    .Reset_n                            (reset_n                   ),
    .SKIP_SAMPLES                       (SKIP_SAMPLES              ),
    .DataNum                            (DataNum                   ),//βɼݸ󲻳FIFO
    .RestartReq                         (RestartReq             ),//ʼź
    .ChannelSel                         (ChannelSel                ),//Ҫͨѡ  ÿһλӦһͨĿ
    .fifowrreq                          (fifowrreq                 ),//ɼдFIFOź
    .fifowrdata                         (fifowrdata                ),//FIFOɼ
    .sample_en                          (ad_sample_en              ),
    .adc_data_flag                      (data_flag                 ),
    .data_1                             (ad_ch1                    ),
    .data_2                             (ad_ch2                    ),
    .data_3                             (ad_ch3                    ),
    .data_4                             (ad_ch4                    ),
    .data_5                             (ad_ch5                    ),
    .data_6                             (ad_ch6                    ),
    .data_7                             (ad_ch7                    ),
    .data_8                             (ad_ch8                    ) 
    );

    
    wire wrfifo_clr;
    wire wrfifo_full;
    wire rdfifo_clr;
    wire rdfifo_rden;
    wire [15:0]rdfifo_dout;
    wire rdfifo_empty;
    wire [15:0] rdfifo_rd_cnt;
    
    
 fifo_axi4_adapter #(
    .FIFO_DW                (16                   ),
    .WR_AXI_BYTE_ADDR_BEGIN (DDR_BASE_ADDR + 1'b1 ),
    .WR_AXI_BYTE_ADDR_END   (DDR_BASE_ADDR + 256*1024*1024-1),
    .RD_AXI_BYTE_ADDR_BEGIN (DDR_BASE_ADDR + 1'b1 ),
    .RD_AXI_BYTE_ADDR_END   (DDR_BASE_ADDR + 256*1024*1024-1),

    .AXI_DATA_WIDTH         (64                   ),
    .AXI_ADDR_WIDTH         (32                   ),
    .AXI_ID                 (4'b0000              ),
    .AXI_BURST_LEN          (8'd15                )  //axi burst length = 16
  )fifo_axi4_adapter_inst
  (
    .start               (RestartReq),
    //clock reset
    .clk                 (loc_clk100m         ),
    .reset               (!reset_n               ),
    //wr_fifo Interface
    .wrfifo_clr          (wrfifo_clr          ),
    .wrfifo_clk          (loc_clk100m             ),
    .wrfifo_wren         (fifowrreq),
    .wrfifo_din          (fifowrdata    ),
    .wrfifo_full         (wrfifo_full         ),
    .wrfifo_wr_cnt       (                    ),
    //rd_fifo Interface
    .rdfifo_clr          (rdfifo_clr          ),
    .rdfifo_clk          (loc_clk100m             ),
    .rdfifo_rden         (rdfifo_rden         ),
    .rdfifo_dout         (rdfifo_dout         ),
    .rdfifo_empty        (rdfifo_empty        ),
    .rdfifo_rd_cnt       (rdfifo_rd_cnt                    ),
    // Master Interface Write Address Ports
    .m_axi_awid          (s_axi_awid          ),
    .m_axi_awaddr        (s_axi_awaddr        ),
    .m_axi_awlen         (s_axi_awlen         ),
    .m_axi_awsize        (s_axi_awsize        ),
    .m_axi_awburst       (s_axi_awburst       ),
    .m_axi_awlock        (s_axi_awlock        ),
    .m_axi_awcache       (s_axi_awcache       ),
    .m_axi_awprot        (s_axi_awprot        ),
    .m_axi_awqos         (s_axi_awqos         ),
    .m_axi_awregion      (s_axi_awregion      ),
    .m_axi_awvalid       (s_axi_awvalid       ),
    .m_axi_awready       (s_axi_awready       ),
    // Master Interface Write Data Ports
    .m_axi_wdata         (s_axi_wdata         ),
    .m_axi_wstrb         (s_axi_wstrb         ),
    .m_axi_wlast         (s_axi_wlast         ),
    .m_axi_wvalid        (s_axi_wvalid        ),
    .m_axi_wready        (s_axi_wready        ),
    // Master Interface Write Response Ports
    .m_axi_bid           (4'b0000             ),
    .m_axi_bresp         (s_axi_bresp         ),
    .m_axi_bvalid        (s_axi_bvalid        ),
    .m_axi_bready        (s_axi_bready        ),
    // Master Interface Read Address Ports
    .m_axi_arid          (s_axi_arid          ),
    .m_axi_araddr        (s_axi_araddr        ),
    .m_axi_arlen         (s_axi_arlen         ),
    .m_axi_arsize        (s_axi_arsize        ),
    .m_axi_arburst       (s_axi_arburst       ),
    .m_axi_arlock        (s_axi_arlock        ),
    .m_axi_arcache       (s_axi_arcache       ),
    .m_axi_arprot        (s_axi_arprot        ),
    .m_axi_arqos         (s_axi_arqos         ),
    .m_axi_arregion      (s_axi_arregion      ),
    .m_axi_arvalid       (s_axi_arvalid       ),
    .m_axi_arready       (s_axi_arready       ),
    // Master Interface Read Data Ports
    .m_axi_rid           (4'b0000             ),
    .m_axi_rdata         (s_axi_rdata         ),
    .m_axi_rresp         (s_axi_rresp         ),
    .m_axi_rlast         (s_axi_rlast         ),
    .m_axi_rvalid        (s_axi_rvalid        ),
    .m_axi_rready        (s_axi_rready        )
  );         
  
  wire [15:0] fifo_data;
wire fifo_wrreq;
wire [13:0]wr_data_count;
   state_ctrl state_ctrl(
    .clk                                (loc_clk100m                       ),
    .reset                              (~reset_n                  ),
    .rd_count                           (rdfifo_rd_cnt             ),
    .SKIP_SAMPLES                       (SKIP_SAMPLES              ),
    .start_sample                       (RestartReq             ),//ADCɼ־ź
    .set_sample_num                     (DataNum                   ),//Ҫɼ32λ4G
    .rdfifo_empty                       (rdfifo_empty              ),//DDR˫˿ģFIFOΪձ־ź
    .rdfifo_dout                        (rdfifo_dout               ),//DDRж16λ
    .wrfifo_full                        (wrfifo_full               ),//DDRдFIFOΪ־ź
    .adc_ch_sel                         (ChannelSel                ),
    .adc_data_flag                      (data_flag                 ),
    .wrfifo_clr                         (wrfifo_clr                ),//DDR˫˿ģдFIFOź
    .rdfifo_clr                         (rdfifo_clr                ),//DDR˫˿ģĶFIFOź
    .rdfifo_rden                        (rdfifo_rden               ),//DDR˫˿ģĶʹź
    .ad_sample_en                       (ad_sample_en              ),//ADCʹܱ־ź
    .uart_fifo_usedw                    (wr_data_count             ),
    .uart_fifo_wrreq                    (fifo_wrreq                ),//̫fifo_txдź
    .uart_fifo_wrdata                   (fifo_data                 ) //Ҫ̫fifo_txд
      );     
      wire payload_req_o;
      wire [7:0]dout;
      wire txempty;
      wire [14 : 0] rd_data_count;
      
         fifo_tx fifo_tx (
    .rst                                (!reset_n                  ),// input wire rst
    .wr_clk                             (loc_clk100m                       ),// input wire wr_clk
    .rd_clk                             (clk125m_o                 ),// input wire rd_clk
    .din                                ({fifo_data[7:0],fifo_data[15:8]}),// input wire [15 : 0] din
    .wr_en                              (fifo_wrreq                 ),// input wire wr_en
    .rd_en                              (payload_req_o             ),// input wire rd_en
    .dout                               (dout                      ),// output wire [7 : 0] dout
    .full                               (                          ),// output wire full
    .empty                              (txempty                   ),
    .rd_data_count                      (rd_data_count             ),// output wire [14 : 0] rd_data_count
    .wr_data_count                      (wr_data_count             ) // output wire [13 : 0] wr_data_count
    ); 
    wire [15:0] lenth_val;
    wire tx_done;
    wire tx_en_pulse;
         //ʹܡݸƿ
    eth_send_ctrl eth_send_ctrl (
    .clk125M                            (clk125m_o                 ),
    .reset_n                            (reset_n                   ),
    .pkt_tx_done                        (tx_done                   ),
    .pkt_tx_en                          (tx_en_pulse               ),
    .eth_txfifo_rdusew                  (rd_data_count             ),
    .total_data_num                     (Number_d1                 ),
    .restart_req                        (RestartReq_0_d1           ),
    .pkt_length                         (lenth_val                 ) 
    );
    wire                                gmii_tx_clk                 ;
    wire                                gmii_txen                   ;
    wire               [   7: 0]        gmii_txd                    ;   
      //̫
  eth_udp_tx_gmii eth_udp_tx_gmii
  (
    .clk125m                            (clk125m_o                 ),
    .reset_p                            (reset                   ),
    .tx_en_pulse                        (tx_en_pulse               ),
    .tx_done                            (tx_done                   ),
    .dst_mac                            (48'hFF_FF_FF_FF_FF_FF     ),
    .src_mac                            (48'h00_0a_35_01_fe_c0     ),
    .dst_ip                             (32'hc0_a8_00_03           ),
    .src_ip                             (32'hc0_a8_00_02           ),
    .dst_port                           (16'd6102                  ),
    .src_port                           (16'd5000                  ),
    .data_length                        (lenth_val                 ),
    .payload_req_o                      (payload_req_o             ),
    .payload_dat_i                      (dout                      ),
    .gmii_tx_clk                        (gmii_tx_clk               ),
    .gmii_txen                          (gmii_txen                 ),
    .gmii_txd                           (gmii_txd                  ) 
  );
  
       gmii_to_rgmii gmii_to_rgmii(
    .reset_n                            (reset_n                   ),  
    .gmii_tx_clk                        (gmii_tx_clk               ),
    .gmii_txd                           (gmii_txd                  ),
    .gmii_txen                          (gmii_txen                 ),
    .gmii_txer                          (1'b0                      ),   
    .rgmii_tx_clk                       (rgmii_tx_clk              ),
    .rgmii_txd                          (rgmii_txd                 ),
    .rgmii_txen                         (rgmii_txen                ) 
   );
endmodule
